  /** hexedit.c - 08/12/99 - v0.2 - by Pasky - and for Linux - more questions? - e-mail to pasky@libra.sinus.cz! ***\
  /=================================================================================================================/
  *     HexEditor - programmer's hexadecimal editor with integrated calculator
  *     Copyright (C) 1999  Petr Baudis <pasky@libra.sinus.cz>
  *
  *     This program is free software; you can redistribute it and/or modify
  *     it under the terms of the GNU General Public License as published by
  *     the Free Software Foundation; either version 2 of the License, or
  *     (at your option) any later version.
  *
  *     This program is distributed in the hope that it will be useful,
  *     but WITHOUT ANY WARRANTY; without even the implied warranty of
  *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *     GNU General Public License for more details.
  *
  *     You should have received a copy of the GNU General Public License
  *     along with this program; if not, write to the Free Software
  *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  \==================================================================================================================\
  *                                                                                                                  * F
  *    This file is protected by the GPL. Please read beggining of some system header file and imagine it            *  R
  *  is written here... No distribution to system not containing GPL allowed.                                        * E
  *                                                                                                                  *  E
  *    And what is it? An useful hexadecimal editor with color support, small notetab and many more... But it is     * D
  *  in an evolution! If you want to help me, please contact me at hexedit@libra.sinus.cz. Any suggestions or        *  O
  *  bug-reports please mail to hexedit-bugs@libra.sinus.cz...                                                       * M
  *                                                                                                                  *
  *    Yes, I think there is a lot of better and more nice hexadecimal programmer editors - but I didn't have        * I
  *  anyone, so I started developing this ugly one. But it is small and... my!                                       *  N
  *                                                                                                                  *
  *    Please rembember my english is horrible and this is practically my first bigger project in C.                 *  T
  *  So I'll welcome all comments about it, any optimalizations, extensions, etc...                                  * H
  *                                                                                                                  *  E
  \******************************************************************************************************************/
  
  /********************************************************\
   * Please see main file (hexedit.c) or attached files   *
   * to get any more informations (TODO, features, etc.). *
  \********************************************************/

#ifndef HEXEDIT_CALCULATOR_H
#define HEXEDIT_CALCULATOR_H
  
#include<config.h>
#include<hexedit.h>
#include<display.h>

extern unsigned int calc_space; /* length of the field for numbers */
extern unsigned int calc_result; /* last result of calculator */
extern unsigned int calc_base; /* current numeric base */
extern int history[CALC_HIST_DEPTH]; /* history of the results */
                                                           /* newest result=history[0], oldest=history[CALC_HIST_DEPTH-1] */
extern int hist_pos; /* position in the history */

extern void
calc_actua (void); /* redraws calculator's field and base prefix */

extern void
calc_draw (void); /* draws calculator */

extern int
calc_shift_hist (void); /* shifts history by one forward (history[x]->history[x+1]) */

extern int
calculator (void); /* gives driving to main calculator's loop (yes, there's some
		      similiarity with main hexedit's loop) - it exits by pressing
		      TAB or ESC (warn! double escape causes to exit hexedit too!) */

#endif /* HEXEDIT_CALCULATOR_H */
